# RVN

Package permettant de manipuler les relevés de notes apogée et la création des pdf ueo.
Future version majeure de la partie python `rvntools` de l'application [relevedenotes](https://git.univ-reunion.fr/sda-misc/sda-relevedenotes/src/branch/master/script)

## Prérequis

Les éléments suivants doivent être installés sur le serveur pour le bon fonctionnement du script python.
> - [Python 3](https://www.python.org/downloads/) (version 3.9 minimum)
> - Gestionnaire de package [PIP](https://pypi.org/project/pip/)
> - Avoir [exiftool](https://exiftool.org/) installé (recommandé pour vérifier l'authenticité du fichier ueo généré)
> - Environnement virtuel (recommandé)

## Installation package

L'ensemble des packages requis pour le bon fonctionnement du script python est disponible dans le fichier [requirements.txt](requirements.txt).

La commande suivante installe les packages répertoriés :
```sh
pip3 install "typer[all]" pandas itsdangerous pydantic openpyxl pyexiftool
```

Installation du package `rvn`
```sh
pip3 install --index-url https://git.univ-reunion.fr/api/packages/sda-python/pypi/simple/ rvn --no-deps 
```

### Configuration

Définir un environnement variable `PASSPARTOUT` qui sera utilisé comme clé pour la génération de différent METADATA des 
fichiers pdf générés

## CLI

### UEO

```sh
$ rvn ueo --help                                                                                                                                   ✔  attestation_ueo_v2   17:19:48 
                                                                                                                                                                                                                                                        
 Usage: main-dev.py ueo [OPTIONS] COMMAND [ARGS]...                                                                                                                                                                                                     
                                                                                                                                                                                                                                                        
 Génération des attestations UEO                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                        
╭─ Options ────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╮
│ --help          Show this message and exit.                                                                                                                                                                                                          │
╰──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╯
╭─ Commands ───────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╮
│ generate                Génère les attestations UEO au format pdf dans un dossier spécifique à partir d'un fichier d'un export excel (fournis par Danae Delonglee danae.delonglee@univ-reunion.fr)                                                   │
│ is-original-file        Permet de savoir si le fichier pdf ueo est le fichier original généré par l'application ou non                                                                                                                               │
╰──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╯
```

* Exemple pour générer les attestations UEO

Pour générer les pdf `ueo`, il faut le récapitulatif excel fournis par Danee Delonglee 
(danae.delonglee@univ-reunion.fr).

Ce récapitulatif excel doit contenir :
- Numero etudiant
- Notes (pas obligatoire)
- Nom
- Prénom
- Libellé code étape de l'étudiant
- Libellé UEO validé par l'étudiant
- Date de naissance


```sh
$ rnv ueo generate "fichier.xlsx" -o "chemin/dossier/sauvegarder" -s 1 -a 2023-2024
```

Cette commande va générer les attestations `ueo` dans le dossier spécifié avec l'option "-o".
