import typer
import sys
from pathlib import Path
sys.path.insert(0, str(Path.cwd().parent))
from rvn.cli import ueo
from rvn.config.settings import VERSION

__version__ = VERSION


def version_callback(value: bool):
    if value:
        typer.echo(f"RVN CLI version: {__version__}")
        raise typer.Exit()


app = typer.Typer()
app.add_typer(ueo.app,
              name='ueo',
              help="Génération des attestations UEO",
              short_help="Génération des attestations UEO")


@app.callback()
def main(
    version: bool = typer.Option(None, "--version", callback=version_callback, is_eager=True),
):
    pass


if __name__ == "__main__":
    app()