from pydantic import BaseModel, Field, RootModel
from rvn.model.response.excel import ExcelUEO
from rvn.config.settings import EXCEL_COLONNES
from typing import Optional, List


class EtudiantForUEO(ExcelUEO):
    """ Class pour match les données étudiantes contenu dans le fichier excel en model de donnée"""
    notes: Optional[float] = Field(default=10, alias=EXCEL_COLONNES['notes'], exclude=True)
    composante: Optional[str] = Field(default=None, alias=EXCEL_COLONNES['composante'], exclude=True)


class ListEtudiantForUEO(RootModel):
    root: List[EtudiantForUEO]
